// import { List } from 'immutable';
//import { Dictionary } from 'typescript-collections';
// import { forEach } from 'typescript-collections/dist/lib/arrays';
// todo: get lodash/fp import to work
// import * as _ from 'lodash';
// In retrospect, this is a hilarious/ingenious way to do the type signature.
// Total throwback to my time spent as a Haskell/Functional Programming tutor.
// I don't know how users will feel about the (staggered)(access)(syntax)
// but it might just be nice ^^
// sidenote: it's not the best for memory consumption at runtime
//           since all these intermediary functions are around in some form then,
//           but I think it shouldn't slow down the program much at all
export const TNode_with_children = (key) => (data) => (child_array) => {
    let res = new TNode(key, data);
    child_array.forEach((child) => res.children.set(child.id, child));
    Object.freeze(res);
    return res;
};
export class TNode {
    constructor(key, data) {
        this.size = 1n;
        this.children = new Map();
        this.max_depth = 0;
        this.id = key;
        this.data = data;
    }
}
/**
 *
 * Constructor for a AutoIndTree<D> node
 *
 * @param data
 * @param child_array
 * @returns
 */
export const TNode_with_children_autoind = (data) => (child_array) => {
    let res = new TNode(0n, data);
    child_array.forEach((child_node, ind) => res.children.set(BigInt(ind), tNode_new_k(BigInt(ind), child_node)));
    return res;
};
export const append_toplevel = (tree) => (node) => {
    let new_child = tree.children;
    new_child.set(node.id, node);
    return {
        ...tree,
        children: new_child,
        max_depth: tree.max_depth == 0 ? 1 : tree.max_depth,
        size: tree.size + 1n,
        // todo: update all metadata
        // like max_depth = max previous n.max_depth+1
    };
};
export function tNode_no_k(d) {
    return new TNode(0n, d);
}
export function tNode_new_k(k, n) {
    return { ...n, k: k };
}
/**
 *
 * @param tree that shall get new child
 * @param node to append - key gets scrubbed and auto assigned
 * @returns
 */
export const append_toplevel_autoind = (tree) => (n) => {
    let new_child_hm = tree.children;
    let new_ind = BigInt(tree.children.size);
    new_child_hm.set(new_ind, { ...n, id: new_ind }); // TODO: test
    return {
        ...tree,
        children: new_child_hm,
        // todo: update all metadata
        // (copy from above when ready)
    };
};
/**
 * TODO: fix that this function mutates t!
 * @param t
 * @returns
 */
export const append_all_toplevel_autoind = (t) => (ns) => {
    let first_new_ind = BigInt(t.children.size);
    ns.forEach((appendee, arr_i) => {
        let new_child = tNode_new_k(first_new_ind + BigInt(arr_i), appendee);
        t.children.set(new_child.id, new_child);
    });
    return t;
};
export const contains = (t) => (p) => {
    // todo
    return false;
};
// EXAMPLE / TEST OBJECTS
const test_tree_1_3 = TNode_with_children(0n)("root of 1-3 tree")([new TNode(0n, "child node #1"),
    new TNode(1n, "the label appearing in a path"),
    new TNode(2n, "or a whole task in Todoist"),
]);
const test_tree_1_4 = append_toplevel_autoind(test_tree_1_3)(new TNode(2n, "2nd root?"));
