export type Fn<A, B> = (p: A) => B;
export type AmountWithUnitA<A> = {
    amount: number;
    unit: A;
};
/**
 * copied from the Typescript Handbook
 * IDK about the Arr type... e.g. why not 'any[]'
 */
export declare function partialCall<T extends Arr, U extends Arr, R>(f: (...args: [...T, ...U]) => R, ...headArgs: T): (...tailArgs: U) => R;
type Arr = readonly unknown[];
/**
 * TYPE/CLASS BUILDING BLOCKS
 */
export type IdAble<A> = {
    id: A;
};
export type LimitAble<A> = {
    limit: A;
};
export type KindAble = {
    kind: string;
};
export type Dir4 = (typeof dir4s)[number];
export declare const dir4s: readonly ["North", "East", "South", "West"];
/**
 * Type: DIRection KeyCodes
 * (small subset of KeyboardEvent.key values)
 */
export type DirKC = (typeof dirKCs)[number];
export declare const dirKCs: readonly ["ArrowUp", "ArrowRight", "ArrowDown", "ArrowLeft"];
export type UDKC = (typeof udKCs)[number];
export declare const udKCs: readonly ["ArrowDown", "ArrowUp"];
export type SpaceOrEnterKC = (typeof spaceOrEnterKCs)[number];
export declare const spaceOrEnterKCs: readonly [" ", "Enter"];
/**
 *
 * @param value to assert type over
 * @param candidates the possible (string-y) values of the type
 * @returns
 */
export declare function isStringLiteralOf<T extends string>(value: any, candidates: readonly T[]): value is T;
export declare function isFreeOfNulls<T>(array: T[]): array is NonNullable<T>[];
/**
 * copied from somewhere, don't remember, don't know if/how it works
 *
 * @param enum_type an enum _type_ (so I assume 'typeof enumObj'?)
 *
 * @returns an array of the enums values
 */
export declare function enumKeys<O extends object, K extends keyof O = keyof O>(enum_type: O): K[];
export {};
