/**
 * copied from the Typescript Handbook
 * IDK about the Arr type... e.g. why not 'any[]'
 */
export function partialCall(f, ...headArgs) {
    return (...tailArgs) => f(...headArgs, ...tailArgs);
}
/**
 * after some reading and deliberation, I've come to prefer string literal types (~= union types) over enums
 * [best comparison article I've found](https://blog.bam.tech/developer-news/should-you-use-enums-or-union-types-in-typescript)
 * To get both the relevant type ("x is one of the enumerated (string) values"),
 * and a way (specifically, an array) to iterate over the values, use the following pattern.
 * notice the 'as const', the different capitalizations, and the trailing 's' on the array
 * (the '[number]' thing is kinda arcane, but oh well)
 */
const someSemanticValues = ['FirstValue', 'SecondOne', 'AndSoOn'];
export const dir4s = ["North", "East", "South", "West"];
export const dirKCs = ["ArrowUp", "ArrowRight", "ArrowDown", "ArrowLeft"];
export const udKCs = ["ArrowDown", "ArrowUp"];
export const spaceOrEnterKCs = [" ", "Enter"];
// TYPE GUARDS
/**
 *
 * @param value to assert type over
 * @param candidates the possible (string-y) values of the type
 * @returns
 */
export function isStringLiteralOf(value, candidates) {
    return candidates.includes(value);
}
export function isFreeOfNulls(array) {
    return array.every((elem) => elem !== null);
}
// ENUM UTILITIES
/**
 * copied from somewhere, don't remember, don't know if/how it works
 *
 * @param enum_type an enum _type_ (so I assume 'typeof enumObj'?)
 *
 * @returns an array of the enums values
 */
export function enumKeys(enum_type) {
    return Object.keys(enum_type).filter(k => Number.isNaN(+k));
}
