/* a simple Maybe type
For something that is safer and works/feels more like in Haskell, see:
https://engineering.dollarshaveclub.com/typescript-maybe-type-and-module-627506ecc5c8#5989
*/
export type Maybe<T> = Just<T> | Nothing
export type Just<T> = { value: T }
export type Nothing = { kind: "NOTHING" }
export const nothing: Nothing = { kind: "NOTHING" } as const
export function fromJust<T>(v: Just<T>): T {
  return v.value
}
export function toJust<T>(v: T): Just<T> {
  return { value: v }
}
// TODO: check the behavior for switching over a Just<Whatever> value.
