import {AmountWithUnitA, LimitAble} from "./TypeUtils";

/* CSS VALUES */



export type CSSLengthSpec = AmountWithUnitA<CSSLengthUnit>

// transforms the structured type to how you'd write it in CSS
export function to_CSS_string(len: CSSLengthSpec) {
  return len.amount.toString() + len.unit
}
/**
TODO: move SizingInfoForList (but maybe not it's constituents) to ListViewComponent
TODO: add | ElemSizing to SizingInfoForList
ElemSizing = {
  kind: "ElemSize"
  height: CSSLengthSpec; // really, it's the font size that's interesting, no?
                         // (and the line height, and the padding, and the margin...)
  width: CSSLengthSpec
}*/

// set+limit to specific dimensions
export type BoxSize = {
  kind: "BoxSize"
  height: CSSLengthSpec;
  width: CSSLengthSpec
}
export type ElemLimit = LimitAble<BigInt> & { kind: "ElemLimit" }


export type ItemPositioningStrat = (typeof itemPositioningStrats)[number];
export const itemPositioningStrats = ["start", "center", "end", "space-between", "space-around"] as const;
// CSS length units (only the subset I think is useful/needed)
export type CSSLengthUnit = (typeof cssLengthUnits)[number];
export const cssLengthUnits = ["px", "rem", "em", "vh", "vw"] as const;
